Subject: bug#58333: Manual PDFs other than en and es fail to build

From: Maxim Cournoyer <[email-masked]>
Date: Thu, 06 Oct 2022 12:02:31 -0400

Hi Ludovic,

Thanks for reporting the issue!

Ludovic Courtès <[email-masked]> writes:

> Hi,
>
> <https://guix.gnu.org/manual/devel/fr> lacks its PDF, and similarly for
> /de (/ru and /zh-cn don’t have the PDF either, but that’s a known
> limitation).

Right.  A known self-caused limitation by Texinfo (for reinventing TeX
things itself in a way that breaks that), according to TeX people I had
asked in #latex.  It's probably fixable by reusing more primitives of
TeX rather than re-implementing them, but I'm no TeX expert!

> When running ‘guix build -f doc/build.scm’, we get hard-to-decipher
> clues (thanks, TeX!):
>
> /gnu/store/sqi9bbxd7czxcnvhmm037yd01vykcgza-texinfo-manual-source/guix.de.texi:21958: TeX capacity exceeded, sorry [input stack size=5000].

I guess the above is a serious warning that may be the cause of the
subsequent failures?  We should try to have it fixed to see if it helps.

> @par ->@endgraf @pretolerance =100 @let @par 
>                                              @endgraf 
> @par ->@endgraf @pretolerance =100 @let @par 
>                                              @endgraf 
> @par ->@endgraf @pretolerance =100 @let @par 
>                                              @endgraf 
> @par ->@endgraf @pretolerance =100 @let @par 
>                                              @endgraf 
> @par ->@endgraf @pretolerance =100 @let @par 
>                                              @endgraf 
> @par ->@endgraf @pretolerance =100 @let @par 
>                                              @endgraf 
> ...
> l.21958 @uref{@uref{https://webssh.huashengdun.org/, WebSSH}}
>                                                              , das einen
> /gnu/store/sqi9bbxd7czxcnvhmm037yd01vykcgza-texinfo-manual-source/guix.de.texi:21958:  ==> Fatal error occurred, no output PDF file produced!
> Transcript written on guix.de.log.
>

[...]

> Failed to produce PDF for language 'fr'!
>
>
> I also see things like:
>
> Writing index file guix.fr.cp
> l.527: Unicode char @u8:. not defined for Texinfo l.527: Unicode char @u8:. not defined for Texinfo
> Missing character: There is no  in font cmr10!
> Missing character: There is no  in font cmr10!
> Missing character: There is no  in font cmr10!
>
>
>
> Two possible culprits I can think of:
>
>   1. Some weird problem in the de/fr translations that would cause
>      problems for PDF output but not for HTML/Info (hard to believe).
>
>   2. A font issue caused by 1cde647cc05c640fbfa6f9779a0d7854bb90e153:
>      that commit removed use of the monolithic texlive, which is good,
>      but maybe the problem that were described in a comment there are
>      not solved?  On this topic, Ricardo recently reminded me of
>      <https://issues.guix.gnu.org/33094#7>.

It's possible the font error seen above was caused by 2., but note that
at the time I made the change from the monolithic to minimal tex
dependencies, the French and German PDFs generation was already broken
(see: https://logs.guix.gnu.org/guix/2022-06-15.log#225709).

-- 
Thanks,
Maxim